/*
    This file is part of Bemused.

    Bemused is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Bemused is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Bemused; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Copyright (C) 2002 Ashley Montanaro.
*/

#ifndef POCKETPLAYER_HANDLER_H__
#define POCKETPLAYER_HANDLER_H__

#include "BemusedServerDlg.h"

class CPocketPlayerHandler : public CAppHandler
	{
public:
	CPocketPlayerHandler();
	virtual ~CPocketPlayerHandler();
	virtual BOOL CheckRunning(const TCHAR* aPath, BOOL aStartAutomatically);
	virtual int GetVersion();
	virtual void GetInfo(unsigned char& aPlayStatus, int& aTotalTime, int& aCurrentTime,
		BOOL& aShuffle, BOOL& aRepeat, char* aSongNameGuess, int aSongNameGuessSize,
		BOOL aWaitForPlaying);
	virtual void PlaySong(const char* aFileName);
	virtual void AddSongToPlaylist(const char* aFileName);
	virtual void SetVolume(int aVolume);
	virtual int GetVolume();
	virtual void Play();
	virtual void Pause();
	virtual void Stop(TStopMode aStopMode);
	virtual void FastForward();
	virtual void Rewind();
	virtual void NextTrack();
	virtual void PreviousTrack();
	virtual void SetShuffle(BOOL aShuffleOn);
	virtual void SetRepeat(BOOL aRepeatOn);
	virtual void GetPlaylist(char*& aPlaylist, int& aPlaylistLength, int& aPlaylistPos);
	virtual void SelectInPlaylist(int aIndex);
	virtual void RemoveAllFromPlaylist();
	virtual void OneSecondTick();
	virtual void GetDetailedInfo(int& aBitRate, int& aSampleRate, int& aChannels);
	virtual void FullScreen();
	virtual void SetSeek(int aSeek);
	virtual void GetPlaylistLength(int& aPlaylistLength);

private:
	HWND iWindowHandle;
	int iPocketPlayerVersion;
	TCHAR iPocketPlayerPath[MAX_PATH];
	};

#endif