// SetupWizard.cpp : implementation file
//

#include "stdafx.h"
#include "bemusedserver.h"
#include "SetupWizard.h"
#include "BemusedServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupWizard dialog


CSetupWizard::CSetupWizard(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupWizard::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupWizard)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	iSetupStage = 0;
}


void CSetupWizard::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupWizard)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupWizard, CDialog)
	//{{AFX_MSG_MAP(CSetupWizard)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_SELECTMUSIC, OnSelectmusic)
	ON_BN_CLICKED(IDC_ADDMUSIC, OnAddmusic)
	ON_BN_CLICKED(IDC_CLEARMUSIC, OnClearmusic)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	ON_BN_CLICKED(IDC_SELECTAPPPATH, OnSelectapppath)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupWizard message handlers

void CSetupWizard::OnNext() 
	{
	iSetupStage++;
#ifdef UNDER_CE
	if (iSetupStage == 1) {
		iSetupStage = 4;
		::ShowWindow(GetDlgItem(IDC_MUSICPATH)->m_hWnd, TRUE);
		iSelectedApplication = 0;
		SendDlgItemMessage(IDC_MUSICPATH, WM_SETTEXT, 0, (LPARAM)_T("\\My Documents"));
	}
#endif

	switch (iSetupStage)
		{
	case 1:
		{
		const TCHAR* setupText = _T("Select the main application you wish to use for controlling ")
			_T("your media files. Bemused will also be set up to control PowerPoint presentations.")
			_T("\r\n\r\nIf you only want to control PowerPoint, select the 'Pocket Slides' option.");
		SendDlgItemMessage(IDC_SETUPTEXT, WM_SETTEXT, 0, (LPARAM)setupText);

		SendDlgItemMessage(IDC_RADIO1, BM_SETCHECK, TRUE, 0);

		::ShowWindow(GetDlgItem(IDC_RADIO1)->m_hWnd, TRUE);
		::ShowWindow(GetDlgItem(IDC_RADIO2)->m_hWnd, TRUE);
		::ShowWindow(GetDlgItem(IDC_RADIO3)->m_hWnd, TRUE);
		::ShowWindow(GetDlgItem(IDC_RADIO4)->m_hWnd, TRUE);
		}
		break;

	case 2:
		{
		::ShowWindow(GetDlgItem(IDC_RADIO1)->m_hWnd, FALSE);
		::ShowWindow(GetDlgItem(IDC_RADIO2)->m_hWnd, FALSE);
		::ShowWindow(GetDlgItem(IDC_RADIO3)->m_hWnd, FALSE);
		::ShowWindow(GetDlgItem(IDC_RADIO4)->m_hWnd, FALSE);

		int selectedApp = GetSelectedApplication();

		if (selectedApp != IDC_RADIO4)
			{
			TCHAR setupText[256];
			_tcscpy(setupText, _T("Enter the path to "));

			switch (selectedApp)
				{
			case IDC_RADIO1: _tcscat(setupText, _T("Winamp 2.")); break;
			case IDC_RADIO2: _tcscat(setupText, _T("Winamp 3.")); break;
			case IDC_RADIO3: _tcscat(setupText, _T("Windows Media Player.")); break;
			default: _tcscat(setupText, _T("???")); break;
				}

			iSelectedApplication = selectedApp - IDC_RADIO1;

			SendDlgItemMessage(IDC_SETUPTEXT, WM_SETTEXT, 0, (LPARAM)setupText);

			::ShowWindow(GetDlgItem(IDC_MUSICPATH)->m_hWnd, TRUE);
			::ShowWindow(GetDlgItem(IDC_SELECTAPPPATH)->m_hWnd, TRUE);
			break;
			}
		else
			{
			iSelectedApplication = 3;
			iSetupStage++;
			// FALL THROUGH
			}
		}

	case 3:
		{
		SendDlgItemMessage(IDC_MUSICPATH, WM_GETTEXT, sizeof(iApplicationPath)/sizeof(TCHAR),
			(LPARAM)iApplicationPath);

		SendDlgItemMessage(IDC_MUSICPATH, WM_SETTEXT, 0, (LPARAM)_T(""));

		::ShowWindow(GetDlgItem(IDC_SELECTAPPPATH)->m_hWnd, FALSE);

		const TCHAR* setupText = _T("Enter the location of the files you'd like to browse with Bemused.")
			_T(" You can enter multiple locations.");
		SendDlgItemMessage(IDC_SETUPTEXT, WM_SETTEXT, 0, (LPARAM)setupText);

		::ShowWindow(GetDlgItem(IDC_MUSICPATH)->m_hWnd, TRUE);
		::ShowWindow(GetDlgItem(IDC_SELECTMUSIC)->m_hWnd, TRUE);
		::ShowWindow(GetDlgItem(IDC_ADDMUSIC)->m_hWnd, TRUE);
		::ShowWindow(GetDlgItem(IDC_CLEARMUSIC)->m_hWnd, TRUE);
		}
		break;

	case 4:
		{
		::ShowWindow(GetDlgItem(IDC_SELECTMUSIC)->m_hWnd, FALSE);
		::ShowWindow(GetDlgItem(IDC_ADDMUSIC)->m_hWnd, FALSE);
		::ShowWindow(GetDlgItem(IDC_CLEARMUSIC)->m_hWnd, FALSE);

		SendDlgItemMessage(IDC_MUSICPATH, WM_GETTEXT, sizeof(iMusicPath)/sizeof(TCHAR),
			(LPARAM)iMusicPath);

		int commPort = iParent->FindCommPortInRegistry();
		TCHAR setupText[256];

		if (commPort > 0)
			{
			swprintf(setupText, _T("COM%d"), commPort);
			SendDlgItemMessage(IDC_MUSICPATH, WM_SETTEXT, 0, (LPARAM)setupText);

			_tcscpy(setupText, _T("To configure the Bluetooth connection to your phone, ")
				_T("a Bluetooth COM port must be selected. The port which Bemused thinks it ")
				_T("should use is given below. This can be changed now or later if it's wrong."));
			}
		else
			{
			SendDlgItemMessage(IDC_MUSICPATH, WM_SETTEXT, 0, (LPARAM)_T("COM5"));

			_tcscpy(setupText, _T("To configure the Bluetooth connection to your phone, ")
				_T("a Bluetooth COM port must be selected. Look at the settings of your Bluetooth ")
				_T("adapter, and enter the 'Incoming Connections' COM port here."));
			}

		SendDlgItemMessage(IDC_SETUPTEXT, WM_SETTEXT, 0, (LPARAM)setupText);
		}
		break;

	case 5:
		{
		SendDlgItemMessage(IDC_MUSICPATH, WM_GETTEXT, sizeof(iCommPortName)/sizeof(TCHAR),
			(LPARAM)iCommPortName);

		const TCHAR* setupText = _T("Setup is complete. Press Next to start using Bemused.");
		SendDlgItemMessage(IDC_SETUPTEXT, WM_SETTEXT, 0, (LPARAM)setupText);
		::ShowWindow(GetDlgItem(IDC_MUSICPATH)->m_hWnd, FALSE);
		}
		break;

	default:
		iParent->InitialiseSettingsFromWizard(iSelectedApplication, iApplicationPath,
			iMusicPath, iCommPortName);
		EndDialog(TRUE);
		break;
		}
	}

void CSetupWizard::SetParentDialog(CBemusedServerDlg* aDialog)
	{
	iParent = aDialog;
	}

void CSetupWizard::OnCancel() 
	{
	EndDialog(FALSE);
	}

void CSetupWizard::OnSelectmusic() 
	{
#ifndef UNDER_CE
	TCHAR rootPath[MAX_PATH];

	LPITEMIDLIST itemList;
	BROWSEINFO browseInfo;
	browseInfo.hwndOwner = m_hWnd;
	browseInfo.pidlRoot = NULL; 
    browseInfo.pszDisplayName = rootPath; 
    browseInfo.lpszTitle = "Select a folder which contains your music.";
    browseInfo.ulFlags = 0;
    browseInfo.lpfn = NULL;
    browseInfo.lParam = 0;
    browseInfo.iImage = 0;
	
	// Display the folder browser.
	itemList = SHBrowseForFolder(&browseInfo);

	if (itemList)
		{
		SHGetPathFromIDList(itemList, rootPath);
		SendDlgItemMessage(IDC_MUSICPATH, WM_SETTEXT, 0, (LPARAM)rootPath);

		// Free the ID list structure.
		LPMALLOC mallocPtr;
		SHGetMalloc(&mallocPtr);
		mallocPtr->Free(itemList);
		}
#endif
	}

void CSetupWizard::OnAddmusic() 
	{
#ifndef UNDER_CE
	char rootPath[MAX_PATH];
	char totalRootPath[MAX_PATH];

	SendDlgItemMessage(IDC_MUSICPATH, WM_GETTEXT, MAX_PATH, (LPARAM)totalRootPath);

	LPITEMIDLIST itemList;
	BROWSEINFO browseInfo;
	browseInfo.hwndOwner = m_hWnd;
	browseInfo.pidlRoot = NULL; 
    browseInfo.pszDisplayName = rootPath; 
    browseInfo.lpszTitle = "Select a folder to add to the list.";
    browseInfo.ulFlags = 0;
    browseInfo.lpfn = NULL;
    browseInfo.lParam = 0;
    browseInfo.iImage = 0;
	
	// Display the folder browser.
	itemList = SHBrowseForFolder(&browseInfo);

	if (itemList)
		{
		SHGetPathFromIDList(itemList, rootPath);

		if (strcmp(totalRootPath, ""))
			strcat(totalRootPath, ";");

		strcat(totalRootPath, rootPath);

		SendDlgItemMessage(IDC_MUSICPATH, WM_SETTEXT, 0, (LPARAM)totalRootPath);

		// Free the ID list structure.
		LPMALLOC mallocPtr;
		SHGetMalloc(&mallocPtr);
		mallocPtr->Free(itemList);
		}
#endif
	}

void CSetupWizard::OnClearmusic() 
	{
	SendDlgItemMessage(IDC_MUSICPATH, WM_SETTEXT, 0, (LPARAM)_T(""));
	}

int CSetupWizard::GetSelectedApplication()
	{
	if (SendDlgItemMessage(IDC_RADIO1, BM_GETCHECK))
		return IDC_RADIO1;

	if (SendDlgItemMessage(IDC_RADIO2, BM_GETCHECK))
		return IDC_RADIO2;

	if (SendDlgItemMessage(IDC_RADIO3, BM_GETCHECK))
		return IDC_RADIO3;

	if (SendDlgItemMessage(IDC_RADIO4, BM_GETCHECK))
		return IDC_RADIO4;

	return IDC_RADIO1;
	}

void CSetupWizard::OnSelectapppath() 
	{
	OPENFILENAME ofn;       // common dialog box structure
	TCHAR path[260];       // buffer for filename

	SendDlgItemMessage(IDC_MUSICPATH, WM_GETTEXT, sizeof(path)/sizeof(TCHAR), (LPARAM) path);

	// Initialise structure.
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = m_hWnd;
	ofn.lpstrFile = path;
	ofn.nMaxFile = sizeof(path);
	ofn.lpstrFilter = NULL;
	ofn.nFilterIndex = 0;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_HIDEREADONLY |    // Hide read-only prompt
                OFN_OVERWRITEPROMPT | // Hide Over-write prompt
                OFN_LONGNAMES  |      // Allow long file names
                OFN_NOVALIDATE |      // Don't validate
                OFN_PATHMUSTEXIST;

	// Display the Open dialog box and get a filename.
	if (GetOpenFileName(&ofn))
		SendDlgItemMessage(IDC_MUSICPATH, WM_SETTEXT, 0, (LPARAM)path);
	}
